UNIT Vesa;

INTERFACE

TYPE  TVesaMode=Record
       Attr     : Word;         
       WinA     : Byte;         
       WinB     : Byte;         
       Gran     : Word;         
       WinSiz   : Word;         
       SegA     : Word;         
       SegB     : Word;         
       WinFunc  : Procedure;    
       Bytes    : Word;         
       Width    : Word;         
       Height   : Word;         
       CharW    : Byte;         
       CharH    : Byte;         
       Planes   : Byte;         
       Bits     : Byte;         
       nBanks   : Byte;         
       Model    : Byte;         
       Banks    : Byte;         
       Pages    : Byte;         
       Reserved : Byte; 
       RedMaskSize   : Byte;    
       RedFieldPos   : Byte;    
       GreenMaskSize : Byte;    
       GreenFieldPos : Byte;    
       BlueMaskSize  : Byte;    
       BlueFieldPos  : Byte;    
       RsvdMaskSize  : Byte;    
       RsvdFieldPos  : Byte;    
       DirColModeInf : Byte;    
       Filler   : Array[0..215] Of Byte; 
     End;

Var VesaMode : TVesaMode;
    BankPre  : Integer;


Procedure GetVesaModeInfo(mode : Word);

Procedure SetBank(Bank : Word);

Function InitVesa(mode : Word) : boolean;

Procedure ModeText;

Function Conversion(Rouge, Vert, Bleu : Byte) : Word;

Procedure SetPixel(x, y, Couleur : Word);

Procedure PrintChar(x, y : Word; Caractere : Char; Couleur, Fond : Word);

procedure Print( x, y : integer; Couleur, Fond : Word; Text : String);

Function GetPixel(x, y : Word) : Word;


IMPLEMENTATION

USES Dos;

Procedure GetVesaModeInfo(mode : Word);

Var Regs : Registers;

Begin
 Regs.ax := $4F01;
 Regs.cx := mode;
 Regs.di := Ofs(VesaMode);
 Regs.es := Seg(VesaMode);
 Intr($10, Regs);
End;

Procedure SetBank(Bank : Word);

Var Numeros : Word;

Begin
  Numeros := Bank * 64 Div VesaMode.Gran;
Asm
  mov ax,4F05h
  mov bx,0
  mov dx,Numeros
  int 10h
  mov ax,4F05h
  mov bx,1
  mov dx,Numeros
  int 10h
End;
End;

Function Conversion(Rouge, Vert, Bleu : Byte) : word;
Begin
 Conversion := (Bleu AND 31) + (Vert AND 63) shl 5 + (Rouge AND 31) shl 11;
End;

Function InitVesa(mode : Word) : boolean;

Var Result : Word;

Begin
Asm
 Mov ax,4F02h
 Mov bx,mode
 Int 10h
 Mov Result,ax
End;
 GetVesaModeInfo(mode);
 If Result = $4F Then InitVesa := True Else InitVesa := False;
End;

Procedure ModeText; assembler;
Asm
 Mov ax,0003h
 Int 10h
End;

Procedure SetPixel(x, y, couleur : Word);

Var Pixel  : LongInt;
    Bank   : Word;

Begin
 if ((y <= 479) AND (x <=639)) then
 Begin
   Pixel := y;
   Pixel := Pixel * 640;
   Pixel := Pixel + x;
   Pixel := Pixel * 2;
   Bank := trunc(Pixel / 65536);
   If BankPre <> Bank Then
   Begin
     SetBank(Bank);
     BankPre := Bank;
   End;
   Memw[$A000:(Pixel - (Bank * 65536))]:= couleur;
 End;
End;

Procedure PrintChar(x, y : Word; Caractere : Char; Couleur, Fond : Word);

type CARADEF = array[0..255,0..7] of byte; 
     CARAPTR = ^CARADEF;            

var  Regs  : Registers;       
     ch    : char;            
     i, k,                    
     Masque : byte;         

const fptr : CARAPTR = NIL; 

begin
  if fptr = NIL then        
    begin                   
      Regs.AH := $11;       
      Regs.AL := $30;       
      Regs.BH := 3;         
      intr( $10, Regs );
      fptr := ptr( Regs.ES, Regs.BP );  
    end;

  if ( Fond = 255 ) then                
    for i := 0 to 7 do 
      begin
        Masque := fptr^[ord(Caractere),i];
        for k := 0 to 7 do
          begin
            if ( Masque and 128 <> 0 ) then 
              SetPixel( x+k, y+i, Couleur );
            Masque := Masque shl 1;
          end;
      end
  else                                    
    for i := 0 to 7 do                    
      begin
        Masque := fptr^[ord(caractere),i];
        for k := 0 to 7 do
          begin
            if ( Masque and 128 <> 0 ) then
              SetPixel( x+k, y+i, Couleur )
            else
              SetPixel( x+k, y+i, Fond );  
            Masque := Masque shl 1;
         end;
      end;
end;

procedure Print( x, y : integer; Couleur, Fond : Word; Text : String);

Var i : Word;                              

begin
 for i:=1 to length(Text) do
   begin
     printchar(x, y,Text[i], Couleur, Fond );
     inc( x, 8 );             
   end;
end;

Function GetPixel(x, y : Word) : Word;

Var Pixel  : LongInt;
    Bank   : Word;

Begin
 if ((y <= 479) AND (x <=639)) then
 Begin
   Pixel := y;
   Pixel := Pixel * 640;
   Pixel := Pixel + x;
   Pixel := Pixel * 2;
   Bank := trunc(Pixel / 65536);
   If BankPre <> Bank Then
   Begin
     SetBank(Bank);
     BankPre := Bank;
   End;
   GetPixel := Memw[$A000:(Pixel - (Bank * 65536))];
 End;
End;

End.